/* Copyright (C) 2010-2012 Red Hat, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

#ifndef _LOGGING_H
#define _LOGGING_H

#ifdef __cplusplus
extern "C" {
#endif

enum log_level {
	IW_LOG_INFO = 0,	/* for log_msg(0,"foo"); */
	IW_LOG_DEBUG
};

extern void log_msg (enum log_level level, const char *fmt, ...)
	__attribute__ ((format (printf, 2, 3)));
extern void log_init (enum log_level level, const char *path);
extern void log_check (void);

#define DPRINTF(fmt, args...) log_msg(IW_LOG_DEBUG, fmt, ##args)

#ifdef __cplusplus
}
#endif

#endif
